﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace Refazer.Web.Models
{
    /// <summary>
    /// Class that represent a fix generated by Refazer to a incorrect submission
    /// </summary>
    public class Fix
    {
        //Id of the generated fix
        [Key, DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public int ID { set; get; }

        //The fixed student submission
        public string FixedCode { set; get; }

        //the student submission id
        public int SubmissionId { set; get; }

        //the id of the experiment where the fix was generated
        public int SessionId { set; get; }

        public int QuestionId { set; get; }

        //Transformation that produced this fix
        public Transformation Transformation { set; get; }

        [Required, DatabaseGenerated(DatabaseGeneratedOption.Computed)]
        public DateTime Time { set; get; }
    }

}